using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace LCDAdapt
{
    public partial class Export_Import : BaseForm
    {
        public Export_Import()
        {
            InitializeComponent();
        }

        static private LcdSettings _lcdSetting;
        public BaseForm.GetLcdSettings GetLcdSettings;
        public BaseForm.SetLcdSettings SetLcdSettings;

        private void Import_btn_Click(object sender, EventArgs e)
        {
            
        }

        private string GetRegistryText()
        {
            if (_lcdSetting.platform == Platforms.CM_T35)
            {
                SettingsBox.ScrollBars = ScrollBars.None;
                return GetRegistryTextCM_T35();
            }
            if (_lcdSetting.platform == Platforms.CM_X300)
            {
                SettingsBox.ScrollBars = ScrollBars.Vertical;
                return GetRegitryTextCM_X300();
            }
            return "";
        }
        private string GetRegistryTextCM_T35()
        {
            return String.Format("[HKEY_LOCAL_MACHINE\\System\\GDI\\Drivers\\Config]\r\n" +
                                "\t\"IsDVIEnabled\"=dword:{0:x}\r\n" +
                                "\t\"IsLVDSEnabled\"=dword:{0:x}\r\n" +
                                "\t\"HorizontalSyncPolarity\"=dword:{1:x}\r\n" +
                                "\t\"VerticalSyncPolarity\"=dword:{2:x}\r\n" +
                                "\t\"Height\"=dword:{3:x}\r\n" +
                                "\t\"Width\"=dword:{4:x}\r\n" +
                                "\t\"HorizontalSyncPulseWidth\"=dword:{5:x}\r\n" +
                                "\t\"VerticalSyncPulseWidth\"=dword:{6:x}\r\n" +
                                "\t\"HorizontalBackPorch\"=dword:{7:x}\r\n" +
                                "\t\"HorizontalFrontPorch\"=dword:{8:x}\r\n" +
                                "\t\"VerticalFrontPorch\"=dword:{9:x}\r\n" +
                                "\t\"VerticalBackPorch\"=dword:{10:x}\r\n" +
                                "\t\"PixelClockFrequency\"=dword:{11:x}\r\n" +
                                "\t\"PixelClockPolarity\"=dword:{12:x}\r\n",
                                _lcdSetting.plat.cm_t35.IsDVIEnabled,
                                _lcdSetting.plat.cm_t35.IsLVDSEnabled,
                                _lcdSetting.plat.cm_t35.Horizontal.SyncPolarity,
                                _lcdSetting.plat.cm_t35.Vertical.SyncPolarity,
                                _lcdSetting.plat.cm_t35.Height,
                                _lcdSetting.plat.cm_t35.Width,
                                _lcdSetting.plat.cm_t35.Horizontal.SyncPulseWidth,
                                _lcdSetting.plat.cm_t35.Vertical.SyncPulseWidth,
                                _lcdSetting.plat.cm_t35.Horizontal.BackPorch,
                                _lcdSetting.plat.cm_t35.Horizontal.FrontPorch,
                                _lcdSetting.plat.cm_t35.Vertical.FrontPorch,
                                _lcdSetting.plat.cm_t35.Vertical.BackPorch,
                                _lcdSetting.plat.cm_t35.PixelClockFrequency,
                                _lcdSetting.plat.cm_t35.PixelClockPolarity);
        }

        private string GetRegitryTextCM_X300()
        {
            return string.Format("[HKEY_LOCAL_MACHINE\\Drivers\\Display\\GPE]\r\n" +
                "\t\"HorizontalSize\"=dword:{0}\r\n" +
                "\t\"VerticalSize\"=dword:{1}\r\n" +
                "\t\"Bpp\"=dword:{2}\r\n" +
                "\t\"BLW\"=dword:{3}\r\n" +
                "\t\"ELW\"=dword:{4}\r\n" +
                "\t\"HSW\"=dword:{5}\r\n" +
                "\t\"BFW\"=dword:{6}\r\n" +
                "\t\"EFW\"=dword:{7}\r\n" +
                "\t\"VSW\"=dword:{8}\r\n" +
                "\t\"104M\"=dword:{9}\r\n" +
                "\t\"156M\"=dword:{10}\r\n" +
                "\t\"208M\"=dword:{11}\r\n" +
                "\t\"39M\"=dword:{12}\r\n" +
                "\t\"D0CS\"=dword:{13}\r\n" +
                "\t\"OEP\"=dword:{14}\r\n" +
                "\t\"PCP\"=dword:{15}\r\n" +
                "\t\"HSP\"=dword:{16}\r\n" +
                "\t\"VSP\"=dword:{17}\r\n" +
                "\t\"Leaded\"=dword:0",
                _lcdSetting.plat.cm_x300.width,
                _lcdSetting.plat.cm_x300.height,
                _lcdSetting.plat.cm_x300.bpp,
                _lcdSetting.plat.cm_x300.horizontal.FrontPorch,
                _lcdSetting.plat.cm_x300.horizontal.BackPorch,
                _lcdSetting.plat.cm_x300.horizontal.SyncPulseWidth,
                _lcdSetting.plat.cm_x300.vertical.FrontPorch,
                _lcdSetting.plat.cm_x300.vertical.BackPorch,
                _lcdSetting.plat.cm_x300.vertical.SyncPulseWidth,
                _lcdSetting.plat.cm_x300.pcd._104m,
                _lcdSetting.plat.cm_x300.pcd._156m,
                _lcdSetting.plat.cm_x300.pcd._208m,
                _lcdSetting.plat.cm_x300.pcd._39m,
                _lcdSetting.plat.cm_x300.pcd.d0cs,
                _lcdSetting.plat.cm_x300.dataenablepolarity,
                _lcdSetting.plat.cm_x300.pixelclockpolarity,
                _lcdSetting.plat.cm_x300.horizontal.SyncPolarity,
                _lcdSetting.plat.cm_x300.vertical.SyncPolarity);
        }
        private string GetXmlText()
        {
            if (_lcdSetting.platform == Platforms.CM_T35)
            {
                return GetXmlTextCM_T35();
            }
            if (_lcdSetting.platform == Platforms.CM_X300)
            {
                return GetXmlTextCM_X300();
            }
            return "";            
        }
        private string GetXmlTextCM_T35()
        {
            return string.Format("<action type=\"update_parameter\" subtype=\"offset\">\r\n" +
                                "\t<target id=\"boot_parameters\"></target>\r\n" +
                                "\t<params param_offset=\"0x100\" param_length=\"4\" param_value=\"0x4c434453\" param_type=\"number\"></params> <!-- Signature-->\r\n" +
                                "\t<params param_offset=\"0x104\" param_length=\"4\" param_value=\"0x{0:x}\" param_type=\"number\"></params> <!-- Height-->\r\n" +
                                "\t<params param_offset=\"0x108\" param_length=\"4\" param_value=\"0x{1:x}\" param_type=\"number\"></params> <!-- Width-->\r\n" +
                                "\t<params param_offset=\"0x10C\" param_length=\"4\" param_value=\"0x{2:x}\" param_type=\"number\"></params> <!-- HorizontalSyncPulseWidth-->\r\n" +
                                "\t<params param_offset=\"0x110\" param_length=\"4\" param_value=\"0x{3:x}\" param_type=\"number\"></params> <!-- HorizontalSyncPolarity-->\r\n" +
                                "\t<params param_offset=\"0x114\" param_length=\"4\" param_value=\"0x{4:x}\" param_type=\"number\"></params> <!-- HorizontalBackPorch-->\r\n" +
                                "\t<params param_offset=\"0x118\" param_length=\"4\" param_value=\"0x{5:x}\" param_type=\"number\"></params> <!-- HorizontalFrontPorch-->\r\n" +
                                "\t<params param_offset=\"0x11C\" param_length=\"4\" param_value=\"0x{6:x}\" param_type=\"number\"></params> <!-- VerticalSyncPulseWidth-->\r\n" +
                                "\t<params param_offset=\"0x120\" param_length=\"4\" param_value=\"0x{7:x}\" param_type=\"number\"></params> <!-- VeritcalSyncPolairty-->\r\n" +
                                "\t<params param_offset=\"0x124\" param_length=\"4\" param_value=\"0x{8:x}\" param_type=\"number\"></params> <!-- VerticalBackPorch-->\r\n" +
                                "\t<params param_offset=\"0x128\" param_length=\"4\" param_value=\"0x{9:x}\" param_type=\"number\"></params> <!-- VerticalFrontPorch-->\r\n" +
                                "\t<params param_offset=\"0x12C\" param_length=\"4\" param_value=\"0x{10:x}\" param_type=\"number\"></params> <!-- PixelClockFrequency-->\r\n" +
                                "\t<params param_offset=\"0x130\" param_length=\"4\" param_value=\"0x{11:x}\" param_type=\"number\"></params> <!-- PixelClockPolarity-->\r\n" +
                                "\t<params param_offset=\"0x134\" param_length=\"4\" param_value=\"0x{12:x}\" param_type=\"number\"></params> <!-- IsDVIEnabled-->\r\n" +
                                "\t<params param_offset=\"0x138\" param_length=\"4\" param_value=\"0x{13:x}\" param_type=\"number\"></params> <!-- IsLVDSEnabled-->\r\n" +
                                "</action>",
                                _lcdSetting.plat.cm_t35.Height,
                                _lcdSetting.plat.cm_t35.Width,
                                _lcdSetting.plat.cm_t35.Horizontal.SyncPulseWidth,
                                _lcdSetting.plat.cm_t35.Horizontal.SyncPolarity,
                                _lcdSetting.plat.cm_t35.Horizontal.BackPorch,
                                _lcdSetting.plat.cm_t35.Horizontal.FrontPorch,
                                _lcdSetting.plat.cm_t35.Vertical.SyncPulseWidth,
                                _lcdSetting.plat.cm_t35.Vertical.SyncPolarity,
                                _lcdSetting.plat.cm_t35.Vertical.BackPorch,
                                _lcdSetting.plat.cm_t35.Vertical.FrontPorch,
                                _lcdSetting.plat.cm_t35.PixelClockFrequency,
                                _lcdSetting.plat.cm_t35.PixelClockPolarity,
                                _lcdSetting.plat.cm_t35.IsDVIEnabled,
                                _lcdSetting.plat.cm_t35.IsLVDSEnabled);
        }
        private string GetXmlTextCM_X300()
        {
            return "";
        }
        private void Exp_btn_Click(object sender, EventArgs e)
        {
            LcdSettings tmp;
            if (GetLcdSettings(out tmp))
            {
                _lcdSetting = tmp;
                SettingsBox.Text = GetRegistryText();
                xmlSettings.Text = GetXmlText();
            }
            else
            {
                MessageBox.Show("Failed to import settings!\r\n\r\n" +
                                "Settings are updated only when:\r\n" +
                                "A. You connect to a device\r\n" +
                                "B. You send settings to a device", "Error");
            }
        }
    }
}